# coding: utf-8
require File.expand_path("../../message", __FILE__)

module Evrone
  module CI
    module Message

      class BuildInfo
        class << self

          def test_attributes(options = {})
            {
              build_id:       1,
              commit_author:  'Автор по русски',
              commit_message: 'Сообщение по русски',
            }.merge(options)
          end

          def test_message(options = {})
            new test_attributes(options)
          end

        end
      end

      class JobStatus
        class << self

          def test_attributes(options = {})
            {
              build_id: 1,
              job_id:   2,
              status:   0,
              tm:       1376137604,
              tm_usec:  1234,
              matrix:   ["env:FOO = 1", "rvm:1.9.3"]
            }.merge(options)
          end

          def test_message(options = {})
            new test_attributes(options)
          end

        end
      end

      class BuildStatus
        class << self

          def test_attributes(options = {})
            {
              build_id: 1,
              status:   0,
              tm:       1376137604,
              tm_usec:  1234,
              jobs_count: 1,
              matrix: %w{ env rvm },

              commit_author:       "Commit Author",
              commit_author_email: "example@example.com",
              commit_sha:          "d3c7576e3b84bd578ce562c6d504cc7a1233adc1",
              commit_message:      "Commit Message"
            }.merge(options)
          end

          def test_message(options = {})
            new test_attributes(options)
          end

        end
      end

      class JobLog
        class << self

          def test_attributes(options = {})
            {
              build_id: 1,
              job_id:   2,
              log:      'log',
              tm:       1376137604,
              tm_usec:  1234,
            }.merge(options)
          end

          def test_message(options = {})
            new test_attributes(options)
          end

        end
      end

      class BuildLog
        class << self

          def test_attributes(options = {})
            {
              build_id: 1,
              log:      'log',
              tm:       1376137604,
              tm_usec:  1234,
            }.merge(options)
          end

          def test_message(options = {})
            new test_attributes(options)
          end

        end
      end

      class PerformJob
        class << self

          def test_attributes(options = {})
            key = File.read File.expand_path("../../../../../fixtures/insecure_private_key", __FILE__)
            options.merge({
              id:         options[:id]           || 1,
              name:       options[:name]         || 'evrone/test-repo',
              src:        options[:src]          || "git@github.com:evrone/ci-worker-test-repo.git",
              sha:        options[:sha]          || "b665f90239563c030f1b280a434b3d84daeda1bd",
              deploy_key: options[:deploy_key]   || key,
              job_id:     options[:job_id]       || 2,
              before_script: options[:before_script] || 'echo before_script',
              script:     options[:script]       || 'echo script',
              matrix_keys: options[:matrix_keys] || %w{ rvm:2.0.0 }
            })
          end

          def test_pull_request_attributes(options = {})
            options = {
              sha: "84158c732ff1af3db9775a37a74ddc39f5c4078f",
              pull_request_id: 4
            }.merge(options)
            test_attributes(options)
          end

          def test_message(options = {})
            new test_attributes(options)
          end

          def test_pull_request_message(options = {})
            new test_pull_request_attributes(options)
          end

        end
      end

      class PerformBuild
        class << self

          def test_attributes(options = {})
            key = File.read File.expand_path("../../../../../fixtures/insecure_private_key", __FILE__)
            options.merge({
              id:         options[:id]         || 1,
              name:       options[:name]       || 'evrone/test-repo',
              src:        options[:src]        || "git@github.com:evrone/ci-worker-test-repo.git",
              sha:        options[:sha]        || "b665f90239563c030f1b280a434b3d84daeda1bd",
              deploy_key: options[:deploy_key] || key
            })
          end

          def test_pull_request_attributes(options = {})
            options = {
              sha: "84158c732ff1af3db9775a37a74ddc39f5c4078f",
              pull_request_id: 4
            }.merge(options)
            test_attributes(options)
          end

          def test_message(options = {})
            new test_attributes(options)
          end

          def test_pull_request_message(options = {})
            new test_pull_request_attributes(options)
          end

        end
      end

    end
  end
end
